diff --git a/include/configs/cgtqmx6eval.h b/include/configs/cgtqmx6eval.h
index 211e75f..ba30cfc 100644
--- a/include/configs/cgtqmx6eval.h
+++ b/include/configs/cgtqmx6eval.h
@@ -17,11 +17,6 @@
 
 #define CONFIG_MACH_TYPE	4122
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(10 * 1024 * 1024)
 
diff --git a/include/configs/cm_fx6.h b/include/configs/cm_fx6.h
index aae3044..8b89278 100644
--- a/include/configs/cm_fx6.h
+++ b/include/configs/cm_fx6.h
@@ -257,11 +257,7 @@
 #define CONFIG_ZERO_BOOTDELAY_CHECK
 #define CONFIG_LOADADDR			0x10800000
 #define CONFIG_SYS_LOAD_ADDR		CONFIG_LOADADDR
-#define CONFIG_CMDLINE_TAG		/* enable passing of ATAGs */
 #define CONFIG_SYS_BOOTMAPSZ	        (8 << 20)
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
 #define CONFIG_SERIAL_TAG
 
 /* misc */
diff --git a/include/configs/embestmx6boards.h b/include/configs/embestmx6boards.h
index a033a63..e86c831 100644
--- a/include/configs/embestmx6boards.h
+++ b/include/configs/embestmx6boards.h
@@ -21,10 +21,6 @@
 
 #define PHYS_SDRAM_SIZE		(1u * 1024 * 1024 * 1024)
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
 #define CONFIG_IMX6_THERMAL
 
 /* Size of malloc() pool */
diff --git a/include/configs/gw_ventana.h b/include/configs/gw_ventana.h
index 1db030b..2169ef1 100644
--- a/include/configs/gw_ventana.h
+++ b/include/configs/gw_ventana.h
@@ -36,12 +36,8 @@
 
 #define CONFIG_MACH_TYPE	4520   /* Gateworks Ventana Platform */
 
-/* ATAGs */
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
+/* Serial ATAG */
 #define CONFIG_SERIAL_TAG
-#define CONFIG_REVISION_TAG
 
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(10 * SZ_1M)
diff --git a/include/configs/mx6_common.h b/include/configs/mx6_common.h
index 0e5706b..33c6203 100644
--- a/include/configs/mx6_common.h
+++ b/include/configs/mx6_common.h
@@ -46,4 +46,10 @@
 #define CONFIG_DISPLAY_CPUINFO
 #define CONFIG_SYS_GENERIC_BOARD
 
+/* ATAGs */
+#define CONFIG_CMDLINE_TAG
+#define CONFIG_SETUP_MEMORY_TAGS
+#define CONFIG_INITRD_TAG
+#define CONFIG_REVISION_TAG
+
 #endif
diff --git a/include/configs/mx6cuboxi.h b/include/configs/mx6cuboxi.h
index c434fa2..5fc7a8c 100644
--- a/include/configs/mx6cuboxi.h
+++ b/include/configs/mx6cuboxi.h
@@ -14,10 +14,6 @@
 #define CONFIG_SPL_MMC_SUPPORT
 #include "imx6_spl.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
 #define CONFIG_IMX6_THERMAL
 
 #define CONFIG_SYS_MALLOC_LEN		(10 * SZ_1M)
diff --git a/include/configs/mx6qarm2.h b/include/configs/mx6qarm2.h
index 22ddbb8..7a124e0 100644
--- a/include/configs/mx6qarm2.h
+++ b/include/configs/mx6qarm2.h
@@ -11,10 +11,6 @@
 
 #include "mx6_common.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(CONFIG_ENV_SIZE + 2 * 1024 * 1024)
 
diff --git a/include/configs/mx6sabre_common.h b/include/configs/mx6sabre_common.h
index aed399d..ad288f4 100644
--- a/include/configs/mx6sabre_common.h
+++ b/include/configs/mx6sabre_common.h
@@ -11,11 +11,6 @@
 
 #include "mx6_common.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 #define CONFIG_IMX6_THERMAL
 
 /* Size of malloc() pool */
diff --git a/include/configs/mx6slevk.h b/include/configs/mx6slevk.h
index 6fe71ff..2fbb0df 100644
--- a/include/configs/mx6slevk.h
+++ b/include/configs/mx6slevk.h
@@ -14,11 +14,6 @@
 #define MACH_TYPE_MX6SLEVK		4307
 #define CONFIG_MACH_TYPE		MACH_TYPE_MX6SLEVK
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(3 * SZ_1M)
 
diff --git a/include/configs/mx6sxsabresd.h b/include/configs/mx6sxsabresd.h
index 5e4a406..e1abbcf 100644
--- a/include/configs/mx6sxsabresd.h
+++ b/include/configs/mx6sxsabresd.h
@@ -18,11 +18,6 @@
 #include "imx6_spl.h"
 #endif
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(3 * SZ_1M)
 
diff --git a/include/configs/nitrogen6x.h b/include/configs/nitrogen6x.h
index 0106c7a..ecfc393 100644
--- a/include/configs/nitrogen6x.h
+++ b/include/configs/nitrogen6x.h
@@ -14,11 +14,6 @@
 
 #define CONFIG_MACH_TYPE	3769
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(10 * 1024 * 1024)
 
diff --git a/include/configs/novena.h b/include/configs/novena.h
index 0138af8..841edac 100644
--- a/include/configs/novena.h
+++ b/include/configs/novena.h
@@ -110,11 +110,6 @@
 #define CONFIG_SPL_MMC_SUPPORT
 #include "imx6_spl.h"			/* common IMX6 SPL configuration */
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Ethernet Configuration */
 #ifdef CONFIG_CMD_NET
 #define CONFIG_FEC_MXC
diff --git a/include/configs/ot1200.h b/include/configs/ot1200.h
index 1596ad8..afd9385 100644
--- a/include/configs/ot1200.h
+++ b/include/configs/ot1200.h
@@ -10,11 +10,6 @@
 
 #include "mx6_common.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN           (10 * 1024 * 1024)
 
diff --git a/include/configs/platinum.h b/include/configs/platinum.h
index de885ab..75d459f 100644
--- a/include/configs/platinum.h
+++ b/include/configs/platinum.h
@@ -144,12 +144,6 @@
  * U-Boot configuration
  */
 
-/* Tag config */
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Board startup config */
 #define CONFIG_BOARD_EARLY_INIT_F
 #define CONFIG_MISC_INIT_R
diff --git a/include/configs/secomx6quq7.h b/include/configs/secomx6quq7.h
index 227dd77..60d8416 100644
--- a/include/configs/secomx6quq7.h
+++ b/include/configs/secomx6quq7.h
@@ -11,10 +11,6 @@
 
 #include "mx6_common.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
 #define CONFIG_BOARD_REVISION_TAG
 
 /* Size of malloc() pool */
diff --git a/include/configs/tbs2910.h b/include/configs/tbs2910.h
index 2dbb2ee..0abb092 100644
--- a/include/configs/tbs2910.h
+++ b/include/configs/tbs2910.h
@@ -16,11 +16,6 @@
 
 #define CONFIG_MACH_TYPE		3980
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 #define CONFIG_BOARD_EARLY_INIT_F
 #define CONFIG_MXC_GPIO
 #define CONFIG_CMD_GPIO
diff --git a/include/configs/titanium.h b/include/configs/titanium.h
index 1b409f6..f09ad8b 100644
--- a/include/configs/titanium.h
+++ b/include/configs/titanium.h
@@ -20,11 +20,6 @@
 #define MACH_TYPE_TITANIUM		3769
 #define CONFIG_MACH_TYPE		MACH_TYPE_TITANIUM
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(2 * 1024 * 1024)
 
diff --git a/include/configs/tqma6.h b/include/configs/tqma6.h
index f7dc1dc..b929d8d 100644
--- a/include/configs/tqma6.h
+++ b/include/configs/tqma6.h
@@ -30,11 +30,6 @@
 #define PHYS_SDRAM_SIZE			(1024u * SZ_1M)
 #endif
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 #define CONFIG_BOARD_EARLY_INIT_F
 #define CONFIG_BOARD_LATE_INIT
 
diff --git a/include/configs/udoo.h b/include/configs/udoo.h
index 1da5d21..c51e05a 100644
--- a/include/configs/udoo.h
+++ b/include/configs/udoo.h
@@ -14,11 +14,6 @@
 #define MACH_TYPE_UDOO		4800
 #define CONFIG_MACH_TYPE	MACH_TYPE_UDOO
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(2 * SZ_1M)
 
diff --git a/include/configs/wandboard.h b/include/configs/wandboard.h
index d903c98..1ec23ee 100644
--- a/include/configs/wandboard.h
+++ b/include/configs/wandboard.h
@@ -18,11 +18,6 @@
 #define MACH_TYPE_WANDBOARD		4412
 #define CONFIG_MACH_TYPE		MACH_TYPE_WANDBOARD
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(10 * SZ_1M)
 
diff --git a/include/configs/warp.h b/include/configs/warp.h
index 874e8d1..83afc7f 100644
--- a/include/configs/warp.h
+++ b/include/configs/warp.h
@@ -15,11 +15,6 @@
 
 #include "mx6_common.h"
 
-#define CONFIG_CMDLINE_TAG
-#define CONFIG_SETUP_MEMORY_TAGS
-#define CONFIG_INITRD_TAG
-#define CONFIG_REVISION_TAG
-
 /* Size of malloc() pool */
 #define CONFIG_SYS_MALLOC_LEN		(35 * SZ_1M) /* Increase due to DFU */
 